#include "so3.hh"
#include "SO3.hh"

so3::operator SO3() const{
  double ct, st, vt, w1, w2, w3;
  
  ct = cos(theta);    st = sin(theta);    vt = 1.0-ct;
  w1 = omega[R3::X];  w2 = omega[R3::Y];  w3 = omega[R3::Z];

  return SO3( R3(w1*w1*vt + ct,      w1*w2*vt + w3*st,   w1*w3*vt - w2*st),
	      R3(w1*w2*vt - w3*st,   w2*w2*vt + ct,      w2*w3*vt + w1*st),
	      R3(w1*w3*vt + w2*st,   w2*w3*vt - w1*st,   w3*w3*vt + ct   ));
}


