#include "R3.hh"

#ifndef __so3_HH__
#define __so3_HH__

class SO3;

class so3{
private:
  R3 omega;
  double theta;
public:

  // this is used to avoid singularities in so3. It's the minimum rotation.
  static const double EPSILON = 0.0000000000001;

  so3(){}
  so3(const R3& w, double t){omega = w; theta = t;}

  R3     w() const {return omega;}
  double t() const {return theta;}

  operator SO3() const;

  friend so3 operator * (double s, const so3& r){return so3(r.w(), r.t()*s);}
  friend so3 operator * (const so3& r, double s){return so3(r.w(), r.t()*s);}

  friend ostream& operator <<  (ostream& s, const so3& r){
    s << r.omega << " " << r.theta;
    return s;
  }
};

#endif
